function [env_sup] = sup_envelop(x)
% Upper envelope of x, based on local extrema;
%	Input: x, a 1D vector.
%	Output: env_sup

x=x(:);
method = 'pchip';
N = length(x);
x=abs(x);
idx_max=find((x(3:end)<x(2:end-1)) & (x(1:end-2)<(x(2:end-1))))+1; 
% post_processing min max
t = (1:N)';

% ending points for superior envelope
xx = x(idx_max);
tt = t(idx_max);

if length(xx)>=2, % at least two maxima in x
    % linear extrapolation of max extremas
    slopei = (xx(2) - xx(1)) / (tt(2) - tt(1)); % initial slope
    xi = slopei*t(1) + xx(1)-slopei*tt(1);
    xi = max(x(1),xi);
    slopef = (xx(end) - xx(end-1)) / (tt(end) - tt(end-1)); % final slope
    xf = slopef*(t(end)-tt(end-1))+xx(end-1);
    xf = max(x(end),xf);
    xx = [xi; xx; xf]; 
    tt = [t(1); tt; t(end)]; 
    env_sup = interp1(tt,xx,t,method);
elseif length(xx)==1,
    xx = [x(1); xx; x(end)]; 
    tt = [t(1); tt; t(end)];
    env_sup = interp1(tt,xx,t,method);
else
    env_sup=[];
    disp('no sup envelope')
end

%plot(t,x,t,env_sup)

