function [vad,ind0,ind1]=vad_short_zero_value_gap_removal_v1(vad,M)

% vad: initial vad binary indicator function
% M: minimum number of zero-value consecutive samples

% Function goal:
% 1) fill in zero-valued gaps shorter then M samples

[ind0,ind1]=find_transition_indices(vad);

if ~isempty(ind0),
    for k=2:2:length(ind0),
        if ((ind0(k)-ind0(k-1)) < M) && ind0(k-1)~=1 && ind0(k)~=length(vad),
            ind0(k)=-1; ind0(k-1)=-1;        
        end
    end

    ind0(ind0==-1)=[];

    vad=ones(size(vad));

    for k=1:2:length(ind0)-1,
        vad(ind0(k):ind0(k+1))=0;
    end
end
[ind0,ind1]=find_transition_indices(vad);


function [ind0,ind1]=find_transition_indices(vad)
% vad: binary indicator function
% ind0: indices of the beginning and end of the zero-valued segments in vad 
% ind1: indices of the beginning and end of the one-valued segments in vad

vad1=vad(1);
vadend=vad(end);

ind1_ini=find(diff(vad)==1)+1;
ind1_end=find(diff(vad)==-1);

ind0_ini=find(diff(~vad)==1)+1;
ind0_end=find(diff(~vad)==-1);

ind1=sort([ind1_ini;ind1_end]);
ind0=sort([ind0_ini;ind0_end]);

if isempty(ind0)&&isempty(ind1),
    % either vad is all 1's or all 0's
    if vad1==1,
        ind1=[1 length(vad)];
        ind0=[];
    else
        ind0=[1 length(vad)];
        ind1=[];
    end
else
    if ~vad1&&(ind0(1)<ind1(1)), % if vad1 is equal to 0
        ind0=[1; ind0];
    end

    if ~vadend&&(ind0(end)>ind1(end)), % if vadend is equal to 0
        ind0=[ind0; length(vad)];
    end

    if vad1&&(ind1(1)<ind0(1)), % if vad1 is equal to 1
        ind1=[1; ind1];
    end

    if vadend&&(ind1(end)>ind0(end)), % if vadend is equal to 1
        ind1=[ind1; length(vad)];
    end
end
